// support stuff for the stunt plane vehicle
exec("./bomber_TireSpring.cs");
exec("./bomber_Explosion.cs");
exec("./bomber_FinalExplosion.cs");
exec("./bomber_Contrail.cs");
exec("./bomber_machinegun.cs");

//we need the jeep add-on for this, so force it to load
%error = ForceRequiredAddOn("Vehicle_Jeep");

if(%error == $Error::AddOn_Disabled)
{
   //A bit of a hack:
   //  we just forced the jeep to load, but the user had it disabled
   //  so lets make it so they can't select it
   JeepVehicle.uiName = "";
}

if(%error == $Error::AddOn_NotFound)
{
   //we don't have the jeep, so we're screwed
   error("ERROR: Vehicle_Bomber - required add-on Vehicle_Jeep not found");
}
else
{
   exec("./Vehicle_bomber.cs"); 
}

$TP::Version=1.1; //Version number, do NOT change this unless you know what you are doing.

if($Support::ShootOnClick<$Prop::Version) {return;} //Newer version already loaded.
$Support::ShootOnClick=$TP::Version;

package ShootOnClick_Pack
{
	function armor::onTrigger(%db,%obj,%slot,%val)
	{
		if(%obj.getClassName()$="Player")
		{
			if(%slot==0)
			{
				if(%val)
				{
					if($Sim::Time<%obj.client.SOC_LastFireTime)
					{
						return;
					}
				}
				%obj.SOC_Shoot(%slot,%val);
			}
		}
		return Parent::onTrigger(%db,%obj,%slot,%val);
	}
};
ActivatePackage(ShootOnClick_Pack);

package ShootOnClick_Pack2
{
	function armor::onTrigger(%db,%obj,%slot,%val)
	{
		if(%obj.getClassName()$="AIPlayer")
		{
			if(%slot==2)
			{
				if(%val)
				{
					if($Sim::Time<%obj.SOC_LastFireTime2)
					{
						return;
					}
				}
				%obj.SOC_Shoot2(%slot,%val);
			}
		}
		return Parent::onTrigger(%db,%obj,%slot,%val);
	}
};
ActivatePackage(ShootOnClick_Pack2);

function repeatedVectorAddwithScale(%vecs)
{
	%vec="0 0 0";
	%cnt=getFieldCount(%vecs);
	for(%i=0;%i<%cnt;%i++)
	{
		%fld=getField(%vecs,%i);
		%tvec=getWords(%fld,0,3);
		%scale=getWord(%fld,3);
		%svec=vectorScale(%tvec,%scale);
		%vec=vectorAdd(%vec,%svec);
	}
	return %vec;
}

function SimObject::getLeftVector(%obj)
{
	return vectorCross(%obj.getEyeVector(),%obj.getUpVector());
}

function SimObject::getRightVector(%obj)
{
	return vectorScale(%obj.getLeftVector(%obj),-1);
}

function Player::SOC_Shoot(%obj,%slot,%val)
{
	if(!%val) {cancel(%obj.SOC_reshoot);return;}
	
	%mnt= %obj.getObjectMount();
	if(!isObject(%mnt))
	{
		return;
	}

	%data= %mnt.getDatablock();
	
	%mountObj= %mnt.getMountNodeObject(%data.shootOnClick_RequiredSlot);
	if(%mountObj!$=%Obj) {return;}
	
	if(%data.shootOnClick)
	{
		//Checks OK, shoot it all.
		%cnt=%data.shootOnClick_ProjectileCount;
		for(%i=0;%i<%cnt;%i++)
		{
			%pos= %mnt.getPosition();
			%PVec= %data.ShootOnClick_Position[%i];
			%VVec= %data.ShootOnClick_Velocity[%i];
			%iPos= repeatedVectorAddwithScale(
			%mnt.getEyeVector() SPC getWord(%PVec,0) TAB
			%mnt.getLeftVector() SPC getWord(%PVec,1) TAB
			%mnt.getUpVector() SPC getWord(%PVec,2)
			);
			%iVel= repeatedVectorAddwithScale(
			%mnt.getEyeVector() SPC getWord(%VVec,0) TAB
			%mnt.getLeftVector() SPC getWord(%VVec,1) TAB
			%mnt.getUpVector() SPC getWord(%VVec,2)
			);
			%scale=%data.ShootOnClick_Scale[%i];
			if(%scale$="") {%scale="1 1 1";}
			%p= new Projectile()
			{
				dataBlock= %data.ShootOnClick_Projectile[%i];
				initialPosition= vectorAdd(%pos,%iPos);
				initialVelocity= %iVel;
				sourceObject= %obj;
				client= %obj.client;
				sourceSlot= %slot;
				scale= %scale;
			};missionCleanup.add(%p);
		}
		serverPlay3d(%data.ShootOnClick_Sound,%pos);
		
		//If hold, schedule.
		if(%data.ShootOnClick_Hold)
		{
			//Delay according to datablocks.
			%obj.SOC_reshoot= %obj.schedule(%data.ShootOnClick_ReshootDelay,SOC_Shoot,%slot,%val);
		}
		%obj.client.SOC_LastFireTime=$Sim::Time+%data.ShootOnClick_ShootDelay/1000;
	}
}

function AIPlayer::SOC_Shoot2(%obj,%slot,%val)
{
	if(!%val) {cancel(%obj.SOC_reshoot2);return;}

	%player = %obj.getMountedObject(0);

	%data= %obj.getDatablock();
	
	%mountObj= %obj.getMountNodeObject(%data.shootOnClick_RequiredSlot2);
	//if(%mountObj!$=%Obj) {return;}
	
	if(%data.shootOnClick2)
	{
		//Checks OK, shoot it all.
		%cnt=%data.shootOnClick_ProjectileCount2;
		for(%i=0;%i<%cnt;%i++)
		{
			%pos= %obj.getPosition();
			%PVec= %data.ShootOnClick_Position2[%i];
			%VVec= %data.ShootOnClick_Velocity2[%i];
			%iPos= repeatedVectorAddwithScale(
			%obj.getEyeVector() SPC getWord(%PVec,0) TAB
			%obj.getLeftVector() SPC getWord(%PVec,1) TAB
			%obj.getUpVector() SPC getWord(%PVec,2)
			);
			%iVel= repeatedVectorAddwithScale(
			%obj.getEyeVector() SPC getWord(%VVec,0) TAB
			%obj.getLeftVector() SPC getWord(%VVec,1) TAB
			%obj.getUpVector() SPC getWord(%VVec,2)
			);
			%scale=%data.ShootOnClick_Scale2[%i];
			if(%scale$="") {%scale="1 1 1";}
			%p= new Projectile()
			{
				dataBlock= %data.ShootOnClick_Projectile2[%i];
				initialPosition= vectorAdd(%pos,%iPos);
				initialVelocity= %iVel;
				sourceObject= %player;
				client= %player.client;
				sourceSlot= %slot;
				scale= %scale;
			};missionCleanup.add(%p);
		}
		serverPlay3d(%data.ShootOnClick_Sound2,%pos);
		
		//If hold, schedule.
		if(%data.ShootOnClick_Hold2)
		{
			//Delay according to datablocks.
			%obj.SOC_reshoot2= %obj.schedule(%data.ShootOnClick_ReshootDelay2,SOC_Shoot2,%slot,%val);
		}
		%obj.SOC_LastFireTime2=$Sim::Time+%data.ShootOnClick_ShootDelay2/1000;
	}
}